.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

.data
pLMpy	dd SomeTable
dwWidthEx	dd 123
SomeTable	dd 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
dwColor	dd 00112233h
Src	dq 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15

.data?
Dest	db 100 dup(?)

.code
start:
	call v0
;	exit

	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	UseVP=1
	if UseVP
		push eax
		mov eax, v3
		invoke VirtualProtect, eax, 256, PAGE_EXECUTE_READWRITE, esp
		mov eax, dwColor
		mov dword ptr xx[2], eax
		pop eax
	endif
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call v0
		counter_end
		print str$(eax), 9, "cycles for v0", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call v1
		counter_end
		print str$(eax), 9, "cycles for v1", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call v2
		counter_end
		print str$(eax), 9, "cycles for v2", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			call v3
		counter_end
		print str$(eax), 9, "cycles for v3", 13, 10
		print chr$(13, 10)
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
v0 proc
	mov esi, offset Src
	mov edi, offset Dest
	mov ecx, 16
;	int 3
cycle:	push ecx
	; Next, load the y coordinate of the shape and multiply it by the width of the image
	mov eax, [esi]
	if 1
		shl eax, 2	; (New) - Replacing multiplication with value taken from a multiplication table
		add eax, pLMpy	; (New) -add the pointer to the middle of the multiplication table (before the midle there are negative values)
		mov eax, dword ptr[eax]	; (New) -load the premultiplied value from the table
	else
		mul dwWidthEx	; This commented out multiplication is replaced by the three previous lines of code (no visible speed gain)
	endif
	add esi, 4	; Advance to the x coordinate
	add eax, [esi]	; Add the x coordinate (it's premultiplied by 4)
	add esi, 4	; Advance to the next y coordinate (for the next iteration)
	; Next, add an absolute address from the picture buffer
	; that will set the location where the shape will be drawn
	add eax, [edi]
	mov eax, offset Dest	; fake
	mov ecx, dwColor	; for now, just load a color (later it will be taken from a table)
	mov [eax], ecx	; write the pixel into the memory - SLOW!!!
	pop ecx
	loop cycle
	retn 0
v0 endp

align 16
v1 proc
	mov esi, offset Src
	mov edi, offset Dest
	mov ecx, 16
;	int 3
cycle:	push ecx
	; Next, load the y coordinate of the shape and multiply it by the width of the image
	mov eax, [esi]
	if 0
		shl eax, 2	; (New) - Replacing multiplication with value taken from a multiplication table
		add eax, pLMpy	; (New) -add the pointer to the middle of the multiplication table (before the midle there are negative values)
		mov eax, dword ptr[eax]	; (New) -load the premultiplied value from the table
	else
		mul dwWidthEx	; This commented out multiplication is replaced by the three previous lines of code (no visible speed gain)
	endif
	add esi, 4	; Advance to the x coordinate
	add eax, [esi]	; Add the x coordinate (it's premultiplied by 4)
	add esi, 4	; Advance to the next y coordinate (for the next iteration)
	; Next, add an absolute address from the picture buffer
	; that will set the location where the shape will be drawn
	add eax, [edi]
	mov eax, offset Dest	; fake
	mov ecx, dwColor	; for now, just load a color (later it will be taken from a table)
	mov [eax], ecx	; write the pixel into the memory - SLOW!!!
	pop ecx
	loop cycle
	retn 0
v1 endp

align 16
v2 proc
	mov esi, offset Src
	mov edi, offset Dest
	mov ecx, 16
;	int 3
cycle:	push ecx
	; Next, load the y coordinate of the shape and multiply it by the width of the image
	mov eax, [esi]
	if 1
		shl eax, 2	; (New) - Replacing multiplication with value taken from a multiplication table
		add eax, pLMpy	; (New) -add the pointer to the middle of the multiplication table (before the midle there are negative values)
		mov eax, dword ptr[eax]	; (New) -load the premultiplied value from the table
	else
		mul dwWidthEx	; This commented out multiplication is replaced by the three previous lines of code (no visible speed gain)
	endif
	; add esi, 4	; Advance to the x coordinate
	add eax, [esi+4]	; Add the x coordinate (it's premultiplied by 4)
	add esi, 8	; Advance to the next y coordinate (for the next iteration)
	; Next, add an absolute address from the picture buffer
	; that will set the location where the shape will be drawn
	add eax, [edi]
	mov eax, offset Dest	; fake
	mov ecx, dwColor	; for now, just load a color (later it will be taken from a table)
	mov [eax], ecx	; write the pixel into the memory - SLOW!!!
	pop ecx
	loop cycle
	retn 0
v2 endp

align 16
v3 proc
	mov esi, offset Src
	mov edi, offset Dest
	mov ecx, 16
	push ebx
	mov ebx, pLMpy
;	int 3
cycle:	; push ecx
	; Next, load the y coordinate of the shape and multiply it by the width of the image
	mov eax, [esi]
	if 1
		if 1
			mov eax, [4*eax+ebx]	; 73-->68
		else
			shl eax, 2	; (New) - Replacing multiplication with value taken from a multiplication table
			add eax, ebx	; (New) -add the pointer to the middle of the multiplication table (before the midle there are negative values)
			mov eax, dword ptr[eax]	; (New) -load the premultiplied value from the table
		endif 
	else
		mul dwWidthEx	; This commented out multiplication is replaced by the three previous lines of code (no visible speed gain)
	endif
	; add esi, 4	; Advance to the x coordinate
	add eax, [esi+4]	; Add the x coordinate (it's premultiplied by 4)
	add esi, 8	; Advance to the next y coordinate (for the next iteration)
	; Next, add an absolute address from the picture buffer
	; that will set the location where the shape will be drawn
	add eax, [edi]
	mov eax, offset Dest	; fake
	if UseVP
xx::		mov dword ptr [eax], 00112233h
	else
		mov edx, dwColor	; for now, just load a color (later it will be taken from a table)
		mov [eax], edx	; write the pixel into the memory - SLOW!!!
	endif 
	; pop ecx
	dec ecx
	jnz cycle
;	loop cycle
	pop ebx
	retn 0
v3 endp


ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]